import { writeNotify } from "pi_ucore/util/ecs";

// 炸弹数组
export class BombList {
    @writeNotify
    times: number = 0; // 放炸弹次数
    @writeNotify
    list: BombType[]; // 炸弹
    @writeNotify
    waitBombs: number[] = []; // 待爆炸的合成炸弹
    @writeNotify
    waitSynthesis: number[] = []; // 待合成的合成炸弹

    superBombType: BombType; // 合成的超级炸弹类型
    waitSynthesisPos: number[][]; // 待合成炸弹的位置
}

// 基础炸弹类型
export enum BombType {
    Bomb1 = 1, // 上T雷
    Bomb2, 	// 右T雷
    Bomb3,  // 下T雷
    Bomb4,	// 左T雷
    Bomb5,	// 上I雷
    Bomb6,  // 右I雷
    Bomb7,  // 下I雷
    Bomb8,  // 左I雷
    Bomb9,  // 上L雷
    Bomb10, // 右L雷
    Bomb11, // 下L雷
    Bomb12, // 左L雷
    Bomb13, // 上反L雷
    Bomb14, // 右反L雷
    Bomb15, // 下反L雷
    Bomb16, // 左反L雷
    Bomb17, // 上方型雷
    Bomb18, // 右方型雷
    Bomb19, // 下方型雷
    Bomb20, // 左方型雷
    Bomb21, // 上Z雷
    Bomb22, // 右Z雷
    Bomb23, // 下Z雷
    Bomb24, // 左Z雷
    Bomb25, // 上反Z雷
    Bomb26, // 右反Z雷
    Bomb27, // 下反Z雷
    Bomb28, // 左反Z雷
    SingleBomb, // 单格雷
    CrossBomb, // 十字雷
    FourBomb, // 四格雷
    SwapBomb, // 交换雷

    NewCrossBomb = 200, // 十字雷
    RowBomb, // 横雷
    ColumnBomb, // 竖雷
    NineGridBomb, // 九宫雷
    AirPlaneBomb, // 飞机雷 随机选一个坐标炸十字
    SplitBomb, // 分裂装置(火箭) 随机选6个坐标
    ChainBomb, // 连锁爆炸 摧毁当前地图数量最多的物品
    RowColumn, // 横竖雷
    ThreeRow, // 三横
    ThreeColumn, // 三竖
    BigGridBomb, // 25宫雷
    AirplaneRow, // 飞机横雷
    AirplaneColumn, // 飞机竖雷
    RocketRow, // 火箭横雷
    RocketColumn, // 火箭竖雷
    AirplaneNineGrid, // 飞机九宫
    ThreeAirplane, // 三飞机
    RocketNineGrid, // 火箭九宫
    RocketAirplane, // 火箭飞机
    BigRocketBomb, // 18发火箭
    SuperColumn, //超级横竖雷
    SuperNineGridBomb, //超级九宫雷
    SuperAirPlaneBomb, //超级飞机雷
    SuperSplitBomb, //超级分裂装置
}