import { writeNotify } from "pi_ucore/util/ecs";
import { AwardType, DataType, EventDataType, NormalLockType, SpecialLockType } from "../component/type";
import { BombType } from "./bomb_list";

export class Collect {
    @writeNotify
    dataList: Map<DataType | NormalLockType | SpecialLockType | BombType | AwardType | EventDataType, number>; // 收集物品数量
    perBoomType: [BombType,number][];
    failCount: number[] = [];

    constructor() {
        this.dataList = new Map();
        this.perBoomType = [];
        this.failCount = [];
    }

    addCount(type, count) {
        let old = this.dataList.get(type) || 0;
        this.dataList.set(type, old + count);
        this.dataList = this.dataList;
    }

    setPerBoomType(_perBoomType) {
        this.perBoomType = _perBoomType;
    }

    setFailCount(_failCount) {
        this.failCount = _failCount;
    }

}